_ENV = AIContext

function init_research_desire()
  
  if not research_progress(empire)
    research_desire = nil
  end

  local my_research = empire:research()

  -- don't want to be too aggressive with the base target,
  -- just try to not fall extraordinarily far behind.
  local base_research_target = 0.5*empire:calc_total_pop() + 5
  research_desire = clamp(base_research_target/my_research, 1, 2)

  -- are we behind?
  for other_empire ; empire.contactable_empires
    local other = empire:known_intel(other_empire)
    local their_research = other.research

    local need_research = 0
    if their_research > my_research*2
      need_research = 1.5
    elseif their_research > my_research*1.5
      need_research = 1
    elseif their_research > my_research
      need_research = 0.5
    end

    if other.hostile
      need_research *= 1.5
    end

    research_desire = max(research_desire, need_research+1)
  end

  --print(empire.name, ..research_desire)
end